# Python3
# -*- coding: utf-8 -*-

import re
import sys
import fileinput
import glob
import os

"""
Dieses Skript sollte in einem Ordner liegen, in dem auch das Switchboard Korpus unter dem Ordnernamen 'swb1_dialogact_annot' zu finden ist:
\..\Switchboard\extractRQandQ.py
\..\Switchboard\swb1_dialogact_annot

Die output-Dateien nach dem Ausführen sind im selben Ordner zu finden:
\..\Switchboard\rhetoricalQuestions.txt
\..\Switchboard\questions.txt
"""

# alle Korpusdaten einlesen und alle rhetorischen Fragen und normale Fragen extrahieren

def read_utt_entities(pathToCorpus):
	user_dir = os.path.join(pathToCorpus)
	file_list = []
	for dirpath, _ , filenames in os.walk(user_dir):
		for name in filenames:
			if name.endswith(".utt"):
				file_list.append(os.path.join(user_dir, dirpath, name)) #Liste enthält die pfade zu den utt. dateien
	return file_list


if __name__ == "__main__":
    
    currentPath = os.path.dirname(os.path.abspath( __file__ ))
    os.chdir("swb1_dialogact_annot")
    switchboardPath = os.getcwd()
    file_list = read_utt_entities(switchboardPath)
    
    rqlines = ""
    qlines = ""
    
    for document in file_list:
        f = open(document, "r")
        for line in f:
            # qh ist der Tag für rhetorische Fragen
            if line.startswith("qh"):
                rqlines += line
                
            # alle Tags für normale Fragen
            elif line.startswith("qy") or line.startswith("qw") or line.startswith("qo") or line.startswith("qr") or line.startswith("qrr") or line.startswith("^d") or line.startswith("^g"):
                qlines += line
                
            else:
                continue
    f.close()
    
    os.chdir("..")
    out1 = open("rhetoricalQuestions.txt", "w")
    out1.write(rqlines)
    out1.close()
    out2 = open("questions.txt", "w")
    out2.write(qlines)
    out2.close()
