# Python3
# -*- coding: utf-8 -*-

import re
import sys
import fileinput
import glob
import os

"""
Dieses Skript sollte in einem Ordner liegen, in dem auch das Switchboard Korpus unter dem Ordnernamen 'swb1_dialogact_annot' zu finden ist:
\..\Switchboard\extractRQandQContext.py
\..\Switchboard\swb1_dialogact_annot

Die output-Dateien nach dem Ausführen sind im selben Ordner zu finden:
\..\Switchboard\rhetoricalQuestionsContext.txt
\..\Switchboard\questionsContext.txt
"""

# alle Korpusdaten einlesen und alle rhetorischen Fragen und normale Fragen sowie deren Kontext extrahieren

def read_utt_entities_context(pathToCorpus):
	user_dir = os.path.join(pathToCorpus)
	file_list = []
	for dirpath, _ , filenames in os.walk(user_dir):
		for name in filenames:
			if name.endswith(".utt"):
				file_list.append(os.path.join(user_dir, dirpath, name)) #Liste enthält die pfade zu den utt. dateien
	return file_list


if __name__ == "__main__":
    
    currentPath = os.path.dirname(os.path.abspath( __file__ ))
    os.chdir("swb1_dialogact_annot")
    switchboardPath = os.getcwd()
    file_list = read_utt_entities_context(switchboardPath)
    
    rqlines = ""
    qlines = ""
    
    """
    Da in den Faellen, in denen vor oder nach der Frage eine andere Person spricht, eine Leerzeile zwischen den Sätzen steht,
    betrachten wir einen Kontext von -2 und +2 um die Frage herum
    """
    lineMinus2 = ""
    lineMinus1 = ""
    qLine = ""
    linePlus1 = ""
    
    for document in file_list:
        f = open(document, "r")
        for linePlus2 in f:
            rqtemp = ""
            qtemp = ""
            # qh ist der Tag für rhetorische Fragen
            if qLine.startswith("qh"):
                if not lineMinus1 == "\n":
                    rqtemp += lineMinus1
                    
                else:
                    rqtemp += lineMinus2
                
                rqtemp += qLine
                
                if not linePlus1 == "\n":
                    rqtemp += linePlus1
                    
                else:
                    rqtemp += linePlus2
                    
                rqlines += rqtemp + "----------\n"
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                
            # alle Tags für normale Fragen
            elif qLine.startswith("qy") or qLine.startswith("qw") or qLine.startswith("qo") or qLine.startswith("qr") or qLine.startswith("qrr") or qLine.startswith("^d")  or qLine.startswith("^g"):
                if not lineMinus1 == "\n":
                    qtemp += lineMinus1
                    
                else:
                    qtemp += lineMinus2
                
                qtemp += qLine
                
                if not linePlus1 == "\n":
                    qtemp += linePlus1
                    
                else:
                    qtemp += linePlus2
                
                qlines += qtemp + "----------\n"
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                
            else:
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                continue
        f.close()
    
    os.chdir("..")
    out1 = open("rhetoricalQuestionsContext.txt", "w")
    out1.write(rqlines)
    out1.close()
    out2 = open("questionsContext.txt", "w")
    out2.write(qlines)
    out2.close()
