#! /usr/bin/python3
# author: Lina Abu-Khader, Philipp Meier, Mehrdad Moslemi, Ines Pisetta

# alle bla's aendern
# reg_ex_rueberkopieren

"""
Legende der Dateien:
ub = unbearbeitet
bt = Text bearbeitet(Klammern und co. entfernt)
rt = nur Text(ohne Tags)
sp = Sprecher + Text
rf = rhetorische Fragen
fr = alle Fragen
"""

import re
import sys
import fileinput
import glob
import os

clnText = ""
file_list = ""

def read_utt_entities_context(pathToCorpus):
    user_dir = os.path.join(pathToCorpus)
    file_list = []
    for dirpath, _ , filenames in os.walk(user_dir):
        for name in filenames:
            if name.endswith(".utt"):
                file_list.append(os.path.join(user_dir, dirpath, name)) #Liste enthält die pfade zu den utt. dateien
    print(file_list)
    return file_list


def read_utt_entities(file_list):
    '''
    Liest die utt-Datei ein und gibt den extrahierten Text zurück
    '''
#    filenames = glob.glob("C:\\Users\\mhmo\\workspace2\\Py\\1718WS\\Softwareprojekt\\swb1_dialogact_annot\\*")    
#    filenames = glob.glob("C:\\Users\\mhmo\\workspace2\\Py\\1718WS\\Softwareprojekt\\swb1_dialogact_annot\\sw12utt\\*")
    lines = ""
#    print(filenames)
    for filename in file_list:
        if filename.endswith(".utt"):
            f = open(filename, "r")
            for line01 in f:
                if line01.startswith("qh"):
                    #print(line01)
                    lines += line01
                else:
                    continue
    
            f.close()
    var01 = open("a0_rf_ub.txt", 'w')
    var01.write(lines)
    var01.close()
    return lines


def reg_ex_prog(lines):
    '''
    Nimmt einen Text (lines) und durchsucht ihn mit Hilfe eines RegEx 
    nach "was wir wollen".
    '''
    clnText = lines
#    print(type(lines))
    clnText = clnText.replace("(.)*:", "")
    clnText = re.sub(r'\*\[\[.*\]\]$', "", clnText)
    clnText = clnText.replace("[", "")
    clnText = clnText.replace("+", "")
    clnText = clnText.replace("]", "")
    clnText = clnText.replace("/", "")
    clnText = clnText.replace("}", "")
    clnText = clnText.replace("{A", "")
    clnText = clnText.replace("{B", "")
    clnText = clnText.replace("{C", "")
    clnText = clnText.replace("{D", "")
    clnText = clnText.replace("{E", "")
    clnText = clnText.replace("{F", "")
    clnText = clnText.replace("{", "")
    clnText = clnText.replace("(", "")
    clnText = clnText.replace(")", "")
    clnText = clnText.replace("#", "")
#    cleanText = cleanText.replace("-", "") #besser beibehalten
    clnText = clnText.replace("   ", " ")
    clnText = clnText.replace("  ", " ")
    
#    print(clnText)
#    print()
    var03 = open("a0_rf_bt.txt", 'w')
    var03.write(clnText)
    var03.close()

    return clnText

"""
def output(lines):
    bla = open ("a0_rf_ub.txt", 'w')
    bla.write(lines)
    bla.close()
"""
   
def output2(clnText):
    var02 = open ("a0_rf_bt.txt", 'w')
    var02.write(clnText)
    var02.close()
   
    
def reg_ex_prog2():
    text = open("a0_rf_bt.txt", 'r')
    cache01 = ""
    for line04 in text:
        #print(line04)
        retext = re.search( '(.*): (.*)?', line04).group(2)
        cache01 += retext + "\n"
        
    var03 = open("a0_rf_ct.txt", 'w')
    var03.write(cache01)
    var03.close()
    return None
    
     
def reg_ex_prog3():
    text03 = open("a0_rf_bt.txt", 'r')
    cache02 = ""
    for line06 in text03:
        retext01 = re.search( '.*([A-Z]{1})\.[0-9].*:(.*)', line06).group(1)
        retext02 = re.search( '.*([A-Z]{1})\.[0-9].*:(.*)', line06).group(2)
        cache02 += retext01 + retext02 + "\n"
        
    var06 = open("a0_rf_sp.txt", 'w')
    var06.write(cache02)
    var06.close()
    return None
    
    
def kontext_qh(file_list):
    
    """
    Da in den Faellen, in denen vor oder nach der Frage eine andere Person spricht, eine Leerzeile zwischen den Sätzen steht,
    betrachten wir einen Kontext von -2 und +2 um die Frage herum
    """
    lineMinus2 = ""
    lineMinus1 = ""
    rqlines = ""
    qlines = ""
    qLine = ""
    linePlus1 = ""
    
    for document in file_list:
        f = open(document, "r")
        for linePlus2 in f:
            rqtemp = ""
            qtemp = ""
            
            # qh ist der Tag für rhetorische Fragen
            if qLine.startswith("qh"):
                if not lineMinus1 == "\n":
                    rqtemp += lineMinus1
                    
                else:
                    rqtemp += lineMinus2
                
                rqtemp += qLine
                
                if not linePlus1 == "--\n":
                    rqtemp += linePlus1
                    
                else:
                    rqtemp += linePlus2
                    
                rqlines += rqtemp + "--\n"
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                
            # alle Tags für normale Fragen
            elif qLine.startswith("qy") or qLine.startswith("qw") or qLine.startswith("qo") or qLine.startswith("qr") or qLine.startswith("qrr") or qLine.startswith("^d")  or qLine.startswith("^g"):
                if not lineMinus1 == "\n":
                    qtemp += lineMinus1
                    
                else:
                    qtemp += lineMinus2
                
                qtemp += qLine
                
                if not linePlus1 == "--\n":
                    qtemp += linePlus1
                    
                else:
                    qtemp += linePlus2
                
                qlines += qtemp + "--\n"
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                                
            else:
                lineMinus2 = lineMinus1
                lineMinus1 = qLine
                qLine = linePlus1
                linePlus1 = linePlus2
                continue
        f.close()
    out1 = open("a0_rf_ko_ub.txt", "w")
    out1.write(rqlines)
    out1.close()
    out2 = open("a0_fr_ko_ub.txt", "w")
    out2.write(qlines)
    out2.close()
    return None 
    
        
def reg_ex_prog10():
    text = open("a0_rf_ko_ub.txt", 'r')
    cache10 = ""
    for line10 in text:
        clnText = line10
        clnText = clnText.replace("(.)*:", "")
        clnText = re.sub(r'\*\[\[.*\]\]$', "", clnText)
        clnText = clnText.replace("[", "")
        clnText = clnText.replace("+", "")
        clnText = clnText.replace("]", "")
        clnText = clnText.replace("/", "")
        clnText = clnText.replace("}", "")
        clnText = clnText.replace("{A", "")
        clnText = clnText.replace("{B", "")
        clnText = clnText.replace("{C", "")
        clnText = clnText.replace("{D", "")
        clnText = clnText.replace("{E", "")
        clnText = clnText.replace("{F", "")
        clnText = clnText.replace("{", "")
        clnText = clnText.replace("(", "")
        clnText = clnText.replace(")", "")
        clnText = clnText.replace("#", "")
        clnText = clnText.replace("   ", " ")
        clnText = clnText.replace("  ", " ")
        clnText = clnText.replace("  ", " ")
#        clnText = clnText.replace("--", "")
        cache10 += clnText
        
    var10 = open("a0_rf_ko_bt.txt", 'w')
    var10.write(cache10)
    var10.close()
    return None
    
        
def reg_ex_prog11():
    text = open("a0_rf_ko_bt.txt", 'r')
    cache11 = ""
    for line11 in text:
        if line11.startswith("\n") or line11.startswith(" ") or line11.startswith("*") or line11.startswith("  ") or line11.startswith("   "):
            continue
        elif line11.startswith("--"):
            cache11 += "\n"
        else:
            print(line11)
            line11 = re.sub(r'\<.*\>', "", line11)
            retext = re.search( '(.*): (.*)?', line11).group(2)
            cache11 += retext + "\n"
            print(retext)
        
    var11 = open("a0_rf_ko_ct.txt", 'w')
    var11.write(cache11)
    var11.close()
    return None
    
     
def reg_ex_prog12():
    text12 = open("a0_rf_ko_bt.txt", 'r')
    cache12 = ""
    for line12 in text12:
        if line12.startswith("\n") or line12.startswith(" ") or line12.startswith("--") or line12.startswith("*") or line12.startswith("  ") or line12.startswith("   "):
            print(line12)
            cache12 += line12
        else:
            retext01 = re.search( '.*([A-Z]{1})\.[0-9].*:(.*)', line12).group(1)
            retext02 = re.search( '.*([A-Z]{1})\.[0-9].*:(.*)', line12).group(2)
            cache12 += retext01 + retext02 + "\n"
        
    var12 = open("a0_rf_ko_sp.txt", 'w')
    var12.write(cache12)
    var12.close()

    return None

    
def run():
    '''
    
    '''
    switchboardPath = os.getcwd()
    file_list = read_utt_entities_context(switchboardPath)
    
    lines = read_utt_entities(file_list)
    #print (lines)
    clnText = reg_ex_prog(lines)
#    output(lines)
    output2(clnText)
    reg_ex_prog2()
    reg_ex_prog3()
    kontext_qh(file_list)
    reg_ex_prog10()
    reg_ex_prog11()
    reg_ex_prog12()

if __name__ == "__main__":
    run()
