import re
import spacy
from collections import defaultdict
from collections import Counter

raw = []
content = []
start_tag = '========================================================================='
flag = False
x = []
tag = "qh"

# Switchboard

with open("sw_0035_4372.utt") as f: #Beispieldatei 
	for line in f:
		if start_tag in line:  # damit erst nach der Trennlinie eingelesen wird
			flag = True
		if flag:
			if len(line)>1:
				content.append(line.strip())


def remove_brackets(rhet_questions):
	"""
	Löscht Klammern aus der Liste von rhetorischen Fragen
	"""
	clean = []
	for item in rhet_questions:
		item = re.sub("\[*\]*\{*\}*\(*\)*", "", item)
		clean.append(item)
	return clean
		#print(item)

def extract_questions(content, tag):
	"""
	Extrahiert aus dem aktuellen die rhetorischen Fragen
	"""
	rhet_questions = []
	for item in content:
		if tag in item:
			rhet_questions.append(item)
	
	return rhet_questions
	
rhet_questions = extract_questions(content, tag)
#print(rhet_questions)			



#Sarkasmus v2 Korpus
def NGram_Creator(y, nGramNumber, PosTAGBool):
	"""
	Funktion, die NGrame erstellt, auch mit POS-Tags
	@Parameter:
	y: enthält den Content der Textdatei
	nGramNumber: Bestimmt die Art von NGramen
	PosTAGBool: Legt fest, ob POS-Tags erstellt werden sollen
	"""
	content = str() # erstellt neuen String
	nlp = spacy.load("en") # englisch datenset wird geladen
	#split = ".\""
	text_list = []
	ngrams = []
	tagged = []
	#ngram_tag = []

	for sublist in y:
		for item in sublist:
		#print(item)
			content += item # string aus liste wird an String a angehängt
			text_list.append(content)
	#print(a)
	#print(t)
	doc = nlp(content) # Variable für spacy wird erstellt
	
	if PosTAGBool:
		for token in doc: # ausgabe von token und token.tag_
			tagged.append(token.tag_)
		#print(token, token.tag_)
		#print(tagged)
		ngram_tag = [tagged[i:i+nGramNumber] for i in range(len(tagged))] #erstllt bigrame
		return ngram_tag
		
	else:
		for sentence in text_list:
			words = sentence.split()
			#print(words)
		ngram = [words[i:i+nGramNumber] for i in range(len(words))]
		return ngram

def divide_text_and_response(y):
	# regex ausdruck für split benötigt
	# nummern drinlassen
	# moeglicher split bei ," oder .," oder ?," oder ","
    content = []
    #test = ',if the founders and early government leaders believed that the modern liberal interpretation of separation of church and state is correct then why is the image of moses carrying the ten commandments carved into the supreme court building? ten commandments stunner: feds lying at supreme court,"ummmmmmm, because it was built in 1932-1935, and has nothing whatsoever to do with the founders or early government leaders, nor with what they believed was correct? you really are the master of the art of self-pwn, archie."'
    for line in y:
        for sentence in line:
            content.append(re.split("(.?\",|,\")", sentence))
	
    for sublist in content:
        if len(sublist) < 2:
            content.remove(sublist)
    clean = [[i for i in nested if len(i) > 4] for nested in content]
    
    return clean
    
def return_reponse(clean):  
    response = []  
    for sublist in clean:
        response.append(sublist[1])
    return response
    
def return_text(clean): 
    text = []  
    for sublist in clean:
        text.append(sublist[0])
    return text



if __name__ == "__main__":
	
    rq = []
    with open("sarcasm_v2.csv") as f:
        for line in f:
            if "RQ" in line:
                line = re.sub("(RQ)*,((notsarc)+|(sarc))+,(RQ_notsarc_[0-9]*)*|(RQ_sarc_[0-9]*)*", "", line) # regex löscht die Kodierung am anfang der zeile
                rq.append(line.split("\n"))
    f.close()
	
	
    testlist = rq[:20] # kleine Liste zum Testen
    #print(NGram_Creator(testlist, 2, True))
    #print(testlist)
    clean = divide_text_and_response(testlist)
    response = return_reponse(clean)
    text = return_text(clean)
    
    # Output Responses
    with open("reponses.txt", "w") as f:
        for line in response:
            f.write(line + "\n\n")
    f.close()
    """
    bigram_POS = NGram_Creator(testlist, 2, True)	
    bigram_words = NGram_Creator(testlist, 2 , False)
    #print(bigram_words)
    #print(bigram_POS)
    
    #https://stackoverflow.com/questions/45019607/count-occurrence-of-a-list-in-a-list-of-lists
    # Zählen der Erscheinungen
    count = Counter(map(tuple, bigram_POS))
    print(count)
		
    # List of lists zu Set umwandeln
    # https://stackoverflow.com/questions/26514179/set-of-list-of-lists-in-python
    Set_POS_BiGrams = set(tuple(row) for row in bigram_POS)
    #print("Set ", Set_POS_BiGrams)
	
    #
    x = []
    #print(len(Set_POS_BiGrams))
    """
	
