import re
import spacy
from collections import defaultdict
from collections import Counter
import itertools

"""
Unterteilt den Sarcasm Corpus in Text und Antwort mit Fokus auf 
rhetorische Fragen. Dabei werden die rhetorischen Fragen extrahiert 
sowie vor - und nachstehende Sätze
"""

def divide_text_and_response(y):
    # nummern drinlassen
    # moeglicher split bei ," oder .," oder ?," oder ","
    content = []
    #test = ',if the founders and early government leaders believed that the modern liberal interpretation of separation of church and state is correct then why is the image of moses carrying the ten commandments carved into the supreme court building? ten commandments stunner: feds lying at supreme court,"ummmmmmm, because it was built in 1932-1935, and has nothing whatsoever to do with the founders or early government leaders, nor with what they believed was correct? you really are the master of the art of self-pwn, archie."'
    for line in y:
        for sentence in line:
            content.append(re.split("(.?\",|,\")", sentence))
	
    for sublist in content:
        if len(sublist) < 2:
            content.remove(sublist)
    clean = [[i for i in nested if len(i) > 4] for nested in content]
    
    return clean
    
def return_reponse(clean):
    # Unterteilt Text und Response  
    response = []  
    for sublist in clean:
        try:
            response.append(sublist[1])
        except IndexError:
            pass
    return response
    
def return_text(clean): 
    text = []  
    for sublist in clean:
        text.append(sublist[0])
    return text
    
def find_question_and_statements(responses):
    # Diese Funktion sucht mithilfe von Regex rhetorische Fragen und 
    # Statements im Sarcasm Corpus.
    # @params
    # responses: Inhalt der Textdatei
    
    before = ""
    after = ""
    output = []
    parser = spacy.load("en")
    
    for line in responses:
        try:
            q = re.search("([^.!?])+\?", line)
            b = re.search(".*(\.[^\.]*\.)(.*?)\?",line)
            a = re.search("\?(\s*[A-Za-z',\s:-]*[\.|\!])", line)
            #print(b)
            question = q.group()
            if b == None:
                before = ""
            else:
                before = b.group()
            if a == None:
                after = ""
            else:
                after = a.group()
            
            final_string = question + "\t" + before + "\t"+ after + "\t" + " ".join(x.tag_ for x in parser(question)) + "\t" + " ".join(x.tag_ for x in parser(before)) + "\t" + " ".join(x.tag_ for x in parser(after)) + "\n"
            output.append(final_string)
            #print(before)
        except AttributeError:
            pass
    with open("preparedInstances_rhet.txt", "w") as g:
        g.writelines(output)

if __name__ == "__main__":
    
    # für responses:
    #funktionierender Regex ausdruck, der Fragen matcht: ([^.!?])+\?
    # Regex ausdruck für Satz danach: ([^.!?])+\?\s*[A-Za-z',\s]*[\.|\!]
    # Regex für Ausruck davor: ([A-Za-z',\s])+\. ([^.!?])+\?
	
    # ([A-Za-z',\".\s])*\. ([^\.A-Za-z\?])* Regex Ausdruck für alles 
    
    
    rq = []
    with open("sarcasm_v2.csv") as f:
        for line in f:
            if "RQ_sarc" in line:
                line = re.sub("(RQ)*,((notsarc)+|(sarc))+,(RQ_notsarc_[0-9]*)*|(RQ_sarc_[0-9]*)*", "", line) # regex löscht die Kodierung am anfang der zeile
                rq.append(line.split("\n"))
    f.close()
	
    #print(rq)
    testlist = rq # kleine Liste zum Testen
    #print(testlist)
    #print(testlist[44])
    #print(NGram_Creator(testlist, 2, True))
    #print(testlist)
    clean = divide_text_and_response(testlist)
    response = return_reponse(clean)
    #text = return_text(clean)
    
    print(response)
    ##print(rq)

    find_question_and_statements(response)
